variables:
  DOCKER_HUB_REPOSITORY: patrickdomnick/maas
  DEPLOYMENT: maas-dev-angular
  SERVICE: angular

stages:
  - build
  - deploy
  - release

cache:
  key: "$CI_COMMIT_REF_NAME"
  paths:
    - node_modules/

# test:angular:
#   image: "node:12-alpine"
#   stage: test
#   script:
#     - apk add --update alpine-sdk python
#     - yarn global add @angular/cli
#     - ng config -g cli.packageManager yarn
#     - npm install
#     - ng build --prod
#     - ng lint
#   rules:
#     - if: '$CI_PIPELINE_SOURCE == "push"'
#       when: on_success
#   artifacts:
#     paths:
#       - dist
#   tags:
#     - maas
#     - dev
#     - k8s

build:docker:dev:
  stage: build
  image:
    name: gcr.io/kaniko-project/executor:debug-v0.23.0
    entrypoint: [""]
  script:
    - echo "{\"auths\":{\"$CI_REGISTRY\":{\"username\":\"$CI_REGISTRY_USER\",\"password\":\"$CI_REGISTRY_PASSWORD\"}}}" > /kaniko/.docker/config.json
    - /kaniko/executor --build-arg environ=dev --context $CI_PROJECT_DIR --dockerfile $CI_PROJECT_DIR/Dockerfile --destination $CI_REGISTRY_IMAGE:0.0.$CI_PIPELINE_IID --destination $CI_REGISTRY_IMAGE:latest
  rules:
    - if: '$CI_PIPELINE_SOURCE == "push" && $CI_COMMIT_TAG == null'
      when: on_success
  tags:
    - maas
    - dev
    - k8s

build:docker:weekly:
  stage: build
  image:
    name: gcr.io/kaniko-project/executor:debug-v0.23.0
    entrypoint: [""]
  script:
    - echo "{\"auths\":{\"$CI_REGISTRY\":{\"username\":\"$CI_REGISTRY_USER\",\"password\":\"$CI_REGISTRY_PASSWORD\"}}}" > /kaniko/.docker/config.json
    - /kaniko/executor --build-arg environ=dev --context $CI_PROJECT_DIR --dockerfile $CI_PROJECT_DIR/Dockerfile --destination $CI_REGISTRY_IMAGE:0.0.$CI_PIPELINE_IID
  rules:
    - if: '$CI_PIPELINE_SOURCE == "schedule"'
      when: always
  tags:
    - maas
    - dev
    - k8s

build:docker:prd:
  stage: build
  image:
    name: gcr.io/kaniko-project/executor:debug-v0.23.0
    entrypoint: [""]
  script:
    - echo "{\"auths\":{\"$CI_REGISTRY\":{\"username\":\"$CI_REGISTRY_USER\",\"password\":\"$CI_REGISTRY_PASSWORD\"}}}" > /kaniko/.docker/config.json
    - /kaniko/executor --build-arg environ=prd --context $CI_PROJECT_DIR --dockerfile $CI_PROJECT_DIR/Dockerfile --destination $CI_REGISTRY_IMAGE:$CI_COMMIT_TAG
  rules:
    - if: '$CI_COMMIT_TAG'
      when: always
  tags:
    - maas
    - prd
    - k8s

deploy:dev:
  stage: deploy
  image: bitnami/kubectl:1.16
  script:
    - kubectl patch deployment $DEPLOYMENT -p "{\"spec\":{\"template\":{\"metadata\":{\"annotations\":{\"date\":\"`date +'%s'`\"}}}}}"
  rules:
    - if: '$CI_PIPELINE_SOURCE == "push" && $CI_COMMIT_TAG == null'
      when: on_success
  tags:
    - maas
    - dev
    - k8s

release:dockerhub:
  stage: release
  image:
    name: gcr.io/go-containerregistry/crane:debug
    entrypoint: [""]
  script:
    - crane auth login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - crane auth login -u $DOCKER_HUB_USER -p $DOCKER_HUB_PASSWORD $DOCKER_HUB_REGISTRY
    - crane copy $CI_REGISTRY_IMAGE:$CI_COMMIT_TAG $DOCKER_HUB_REPOSITORY:$CI_COMMIT_TAG
    - crane tag $DOCKER_HUB_REPOSITORY:$CI_COMMIT_TAG latest
  rules:
    - if: '$CI_COMMIT_TAG'
      when: on_success
  tags:
    - maas
    - prd
    - k8s


release:helm:
  stage: release
  image: curlimages/curl:7.72.0
  script:
    - curl -X POST -F token=$HELM_WEBHOOK -F ref=master -F variables[TAG]="$CI_COMMIT_TAG" -F variables[SERVICE]="$SERVICE" https://gitlab.com/api/v4/projects/19636156/trigger/pipeline
  rules:
    - if: '$CI_COMMIT_TAG'
      when: on_success
  tags:
    - maas
    - prd
    - k8s

# pages:
#   image: "node:alpine"
#   stage: release
#   script:
#     - npm -g config set user root
#     - npm install -g "@compodoc/compodoc"
#     - npm run compodoc
#   artifacts:
#     paths:
#     - public
#   tags:
#   - docker
